"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _gulp = _interopRequireDefault(require("gulp"));

var _through = _interopRequireDefault(require("through2"));

var _path2 = _interopRequireDefault(require("path"));

var _del = _interopRequireDefault(require("del"));

var _gulpConcat = _interopRequireDefault(require("gulp-concat"));

var _gulpRename = _interopRequireDefault(require("gulp-rename"));

var _aliOss = _interopRequireDefault(require("ali-oss"));

var _fs = _interopRequireWildcard(require("fs"));

var _gulpCssFormat = _interopRequireDefault(require("gulp-css-format"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

// const ASSETS_URL = 'https://devimg.sunlands.wang';
// const ASSETS_PATH = '1114'
function _default(opts = {}) {
  const _opts$cwd = opts.cwd,
        cwd = _opts$cwd === void 0 ? process.cwd() : _opts$cwd,
        watch = opts.watch,
        entry = opts.entry,
        filename = opts.filename,
        env = opts.env,
        ifBd = opts.ifBd; // gulp.task('replaceScript', () => replaceScript(cwd));
  // gulp.task('uploadFiles', ['replaceScript'], () => uploadFiles({ cwd, env, filename }));

  const run = _gulp.default.series(cb => replaceScript(cwd, ifBd, cb), cb => uploadFiles({
    cwd,
    ifBd,
    filename
  }, cb));

  run(); // uploadFiles({ cwd, env, filename });
  // del(['./dist']);
  // uploadImg(cwd);
  // transformHtml(cwd);
  // transformStyle(cwd);
}

function uploadFiles({
  cwd,
  ifBd,
  filename
}) {
  const client = new _aliOss.default({
    region: 'oss-cn-beijing',
    accessKeyId: 'LTAIuiKdkWndO0zA',
    accessKeySecret: 'oe2VcpFF58QAJl5mhF9mqamVAtXsK2'
  });
  let bucket = 'xiaochengxu-prod';
  let ASSETS_PATH = 'html/' + filename;

  if (ifBd) {
    bucket = 'baiduxcx';
  }

  client.useBucket(bucket);

  const redFile = (cwd, basename) => {
    _fs.default.readdir(cwd, (err, files) => {
      files.forEach(item => {
        const _path = _path2.default.join(cwd, item);

        _fs.default.stat(_path,
        /*#__PURE__*/
        function () {
          var _ref = _asyncToGenerator(function* (err, stats) {
            if (stats.isDirectory()) {
              redFile(_path, item);
            } else {
              const stream = _fs.default.createReadStream(_path);

              let clientname = `${ASSETS_PATH}/${item}`;

              if (basename) {
                clientname = `${ASSETS_PATH}/${basename}/${item}`;
              }

              const result = yield client.put(clientname, stream);
              console.info(result);
            }
          });

          return function (_x, _x2) {
            return _ref.apply(this, arguments);
          };
        }());
      });
    });
  };

  redFile(cwd);
}

function replaceScript(cwd, ifBd) {
  return _gulp.default.src(_path2.default.resolve(cwd, 'index.html')).pipe(_through.default.obj(function (file, enc, cb) {
    let contents = file.contents.toString('utf-8');
    contents = contents.replace(/http\:\/\/ggtf\.sunland\.org\.cn\/statistics\/interactive\.js/g, ifBd ? 'https://www.sunlands.wang/wtm.js' : 'https://img.sunlands.wang/wtm.js');
    contents = contents.replace(/http\:\/\/ggtf\.sunland\.org\.cn\/statistics\/sunlandsLog\.js/g, ifBd ? 'https://b.bdstatic.com/searchbox/icms/searchbox/js/swan-1.6.0.js' : 'https://res.wx.qq.com/open/js/jweixin-1.3.2.js');
    file.contents = new Buffer(contents); // file.path = file.path.replace('.html', '.wxml');

    this.push(file);
    cb();
  })).pipe((0, _gulpRename.default)({
    basename: 'home'
  })).pipe(_gulp.default.dest('./'));
}

function uploadImg(_x3) {
  return _uploadImg.apply(this, arguments);
}

function _uploadImg() {
  _uploadImg = _asyncToGenerator(function* (cwd) {
    let bucket = 'xiaochengxu-001'; // if (env === 'production') {
    //   bucket = 'xiaochengxu-prod';
    // }

    client.useBucket(bucket);

    const dist = _path2.default.join(cwd, 'images');

    _fs.default.readdir(dist,
    /*#__PURE__*/
    function () {
      var _ref2 = _asyncToGenerator(function* (err, files) {
        files.forEach(
        /*#__PURE__*/
        function () {
          var _ref3 = _asyncToGenerator(function* (item) {
            const stream = _fs.default.createReadStream(`${dist}/${item}`);

            const result = yield client.put(`${ASSETS_PATH}/${item}`, stream);
            console.info(result);
          });

          return function (_x6) {
            return _ref3.apply(this, arguments);
          };
        }());
      });

      return function (_x4, _x5) {
        return _ref2.apply(this, arguments);
      };
    }());
  });
  return _uploadImg.apply(this, arguments);
}

function transformHtml(cwd) {
  _gulp.default.src(_path2.default.resolve(cwd, 'index.html')).pipe(_through.default.obj(function (file, enc, cb) {
    const contents = file.contents.toString('utf-8');
    const body = getBody(contents);
    let result = body.replace(/(\<\/?)((body)|(div)|(section))/g, '$1view');
    result = result.replace(/\<img/g, '<image');
    result = result.replace(/images\/(.*)/g, `${ASSETS_URL}/${ASSETS_PATH}/$1`);
    file.contents = new Buffer(result);
    file.path = file.path.replace('.html', '.wxml');
    this.push(file);
    cb();
  })).pipe(_gulp.default.dest('./dist/'));
}

function transformStyle(cwd) {
  _gulp.default.src(_path2.default.resolve(cwd, 'css', '*.css')).pipe((0, _gulpConcat.default)('index.css')).pipe((0, _gulpRename.default)({
    extname: '.wxss'
  })).pipe((0, _gulpCssFormat.default)({
    indent: 1,
    hasSpace: true
  })).pipe(_through.default.obj(function (file, enc, cb) {
    let contents = file.contents.toString('utf-8');
    contents = contents.replace(/\.\.\/images\/(.*)/g, `${ASSETS_URL}/${ASSETS_PATH}/$1`);
    contents = contents.replace(/\*\{([\s\S]+?)\}/g, '');
    contents = contents.replace(/-*(\d*\.*\d+)rem/g, (str, $1, $2) => {
      let num = parseFloat($1);
      num = num * 75;
      return num + 'rpx';
    });
    file.contents = new Buffer(contents);
    this.push(file);
    cb();
  })).pipe(_gulp.default.dest('./dist/'));
}

function getBody(contents) {
  const body = contents.match(/\<body([\s\S]+)\<\/body\>/)[0];
  return body.replace(/\<script([\s\S]+?)\<\/script\>/g, '');
}